(function($){
  'use strict';

  /***********************
       FLUID ANCHORS
  ***********************/

  $('.kw-js-fluidAnchor').click(function(){  
    var id = $(this).attr("href"),
        offset = ($(id).offset().top) - 80;
    $('html, body').animate({scrollTop: offset}, 'slow'); 
    return false;  
  }); 

   
  /***********************
          SLIDERS       
  ***********************/

  // This function 're-slick' on resize. Does not exist in native slick plugin.
  function responsiveSlick() {  
    if (matchMedia('(max-width: 599px)').matches) {

      /*** SMALL SCREENS ***/
      var smallScreenSettings = {speed: 300, slidesToShow: 1, slidesToScroll: 1, respondTo: 'slider', arrows: false, dots: true };
      // Block intro
      if ($('.kw-blockIntro-gallery').hasClass('slick-initialized')) {
        $('.kw-blockIntro-gallery').slick('unslick');
        $('.kw-blockIntro-gallery').slick(smallScreenSettings);
      } else {
        $('.kw-blockIntro-gallery').slick(smallScreenSettings);
      };
      // Cards sliders
      if ($('.kw-cardSliderWrapper').hasClass('slick-initialized')) {
        $('.kw-cardSliderWrapper').slick('unslick');
        $('.kw-cardSliderWrapper').slick(smallScreenSettings);
      } else {
        $('.kw-cardSliderWrapper').slick(smallScreenSettings);
      };
      //Product full sheet
      if ($('.kw-productFull').hasClass('slick-initialized')) {
        $('.kw-productFull').slick('unslick');
        $('.kw-productFull').slick(smallScreenSettings);
      } else {
        $('.kw-productFull').slick(smallScreenSettings);
      };
      
      
    } else if (matchMedia('(min-width: 600px) and (max-width: 999px)').matches) {

      /*** MEDIUM SCREENS ***/
      var mediumScreenSettings = {speed: 300, slidesToShow: 2, slidesToScroll: 1, respondTo: 'slider', arrows: false, dots: true }
      // Add infinite : false
      var mediumScreenSettings2 = {speed: 300, slidesToShow: 2, slidesToScroll: 1, respondTo: 'slider', arrows: false, dots: true, infinite: false }
      // Special settings for product slides
      var mediumScreenSettings3 = {speed: 300, slidesToShow: 1, slidesToScroll: 1, respondTo: 'slider', arrows: false, dots: true };
      // Block intro 
      if ($('.kw-blockIntro-gallery').hasClass('slick-initialized')) {
        $('.kw-blockIntro-gallery').slick('unslick');
        $('.kw-blockIntro-gallery').slick(mediumScreenSettings);
      } else {
        $('.kw-blockIntro-gallery').slick(mediumScreenSettings);
      };
      // Cards sliders
      if ($('.kw-cardSliderWrapper').hasClass('slick-initialized')) {
        $('.kw-cardSliderWrapper').slick('unslick');
        $('.kw-cardSliderWrapper').slick(mediumScreenSettings2);
      } else {
        $('.kw-cardSliderWrapper').slick(mediumScreenSettings2);
      };
      //Product full sheet
      if ($('.kw-productFull').hasClass('slick-initialized')) {
        $('.kw-productFull').slick('unslick');
        $('.kw-productFull').slick(mediumScreenSettings3);
      } else {
        $('.kw-productFull').slick(mediumScreenSettings3);
      };      

    } else if (matchMedia('(min-width: 1000px)').matches) {

      /*** LARGE SCREENS ***/
      // Block intro 
      if ($('.kw-blockIntro-gallery').hasClass('slick-initialized')) {
        $('.kw-blockIntro-gallery').slick('unslick');
      };
      // Cards sliders
      if ($('.kw-cardSliderWrapper').hasClass('slick-initialized')) {
        $('.kw-cardSliderWrapper').slick('unslick');
      };
      // Product full sheet
      if ($('.kw-productFull').hasClass('slick-initialized')) {
        $('.kw-productFull').slick('unslick');
      };   
    }
  }

  window.addEventListener('resize', responsiveSlick, false);
  document.addEventListener('DOMContentLoaded', responsiveSlick, false);


  /***********************
      HIDE AND DISPLAY
  ***********************/

  $.fn.hideAndSeek = function(options){
      //Options
      var settings = $.extend({
          targetToDisplay: $(this).siblings('.kw-js-hidden'),
          hiddenTextButton: '-',
      }, options );
      // Vars
      var that = $(this),
          target = settings.targetToDisplay,
          targetIsDisplayed = $(target).hasClass('kw-is-displayed'),
          originalTextButton = $(this).text(),
          newTextButton = settings.hiddenTextButton;
      // Display or hide
      $(that).click(function() {
        if (!targetIsDisplayed) {
          $(target).addClass('kw-is-displayed');
          $(that).addClass('kw-is-active').text(newTextButton);
          targetIsDisplayed = true;
        } else {
          $(target).removeClass('kw-is-displayed');
          $(that).removeClass('kw-is-active').text(originalTextButton);
          targetIsDisplayed = false;
        }
        return targetIsDisplayed;
      });
  };
  
  $('.js-mobile-displayButton').hideAndSeek({
    targetToDisplay: $('.kw-js-mobile-hidden')
  });



  /***********************
        TAB SYSTEM
  ***********************/

  $('.kw-specialTabsToggle-item a').click(function(event) {
      event.preventDefault();
      // Hide item (reset), then display the corresponding $(this) item.
      $('.kw-specialTabsToggle-item a').removeClass('kw-isActive');
      $(this).addClass('kw-isActive');
      var tab = $(this).attr('href');
      $('.kw-specialTabsContent-item').removeClass('kw-isDisplayed');
      $(tab).addClass('kw-isDisplayed');
      // Auto scroll to the item
      if (matchMedia('(max-width: 599px)').matches) {
        var tabOffset = ($('#kw-specialTabsContent-1').offset().top) - 160;
      } else {
        var tabOffset = ($('#kw-specialTabsToggler-1').offset().top) - 80;
      }
      $('html, body').animate({scrollTop: tabOffset}, 'slow'); 
  });

  $('.kw-js-closeTabItem').click(function(event) {
      event.preventDefault();
      $('.kw-specialTabsToggle-item a').removeClass('kw-isActive');
      $('.kw-specialTabsContent-item').removeClass('kw-isDisplayed');
  });


  /***********************
        POPIN SYSTEM
  ***********************/

  $('.kw-js-popinToggle').click(function(event) {
      event.preventDefault();
      var kwPopinContainerHeight = $('.kw-productPreview-container').outerHeight(),
          kwPopinPosition = $('.kw-js-popin').height( kwPopinContainerHeight + 50 ).css('top', - (kwPopinContainerHeight + 50));
      $('.kw-productPreview-container').addClass('kw-js-popinOverlay')
      $('.kw-js-popinToggle').removeClass('kw-isActive');
      $(this).addClass('kw-isActive');
      var tab = $(this).attr('href');
      $('.kw-js-popin').removeClass('kw-js-popin-isActive');
      $(tab).addClass('kw-js-popin-isActive');
      //Scroll to the popin's top bound
      var offset = $('.kw-productPreview-container').offset().top 
      $('html, body').animate({scrollTop: offset}, 'slow'); 
  });

  $('.kw-js-closePopinItem').click(function(event) {
      event.preventDefault();
      $('.kw-js-popinToggle').removeClass('kw-isActive');
      $('.kw-js-popin').removeClass('kw-js-popin-isActive');
      $('.kw-productPreview-container').removeClass('kw-js-popinOverlay');
      $('.kw-js-popin').height( 0 ).css('top', 0 );
  });  


  /***********************
    RESPONSIVE YOUTUBE
  ***********************/

  function responsiveYoutube() {  
    if (window.matchMedia("(max-width: 560px)").matches) {
      var bodyWidth = $('body').width(),
          newWidth = bodyWidth + 17,
          newHeight = newWidth / 1.88888;
      $('.kw-youtubeVideo').width(newWidth).height(newHeight);
    };
    
  };

  window.addEventListener('resize', responsiveYoutube, false);
  document.addEventListener('DOMContentLoaded', responsiveYoutube, false);


})(jQuery);
